__doc__ = """\
Project:IIGFS
Start:  Fri Aug 16 21:54:20 MSD 2002
Author: Andrey Orlov (c) 2002
Version $Id: MailDistribution.py,v 1.15 2002/11/24 20:27:32 cray Exp $

Title:   
        IIGFS / Mail Distribution

Description:

        Sending news into mail distribution, for use with mailq.py
        and IIGFS only! It is connector for mailq.py spooler and
        will be useless without iigfs.

        Inherited object are to provide getmessagebody function
        returned object, ma be convereted into MIME.
        
        Customizing slots :

            getbodymessage      - return message body, may be as MIME;

            getmaildistributions  - return address list for send message
                by them;

            message_send - do sending attmempt, must only put message into
                spooler queue, some Denial of Service can happened
                otherwise!

Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied 
        
TODO:   
        Nothing


"""
__version__ = '$Revision: 1.15 $'[11:-2]
# $Source: /var/lib/cvs/IIGFS/zope/Products/OtherBases/MailDistribution.py,v $

from Globals import default__class_init__
import string
import DateTime

from MOFS import l10n
_ = l10n.getL10n_decoder(__file__,'OtherBases')
HTMLFile = l10n.HTMLFile

def filter_maildistribution(ob) :
    try :   
        if ob.cfg('have_maildistribution',0) :
            return 1
        else :
            return 0
    except :
            return 0


class MailDistribution :
    """    -"""

    meta_type = 'MailDistribution' 

    _properties =   (
#       {'id':'last_send_date', 'name':'  ', 'type': 'date',  'mode':'w'},
       {'id':'last_send_maillist', 'name':_('Address list of the last distribution'), 'type': 'lines',  'mode':'w'},
       {'id':'last_send_count', 'name':_('Number of distribution attempts'), 'type': 'int',  'mode':'w'},
    )

    __ac_permissions__= (
        ('View IIGFS managment',    ('form_flags_other_items',)),
        ('Use MailDistribution',    ('manage_maildistribution','is_empty_maillist'
                'getmailaddressline','getbodymessage','getmaildistributions','message_send','manage_maildistribution_send',
                'manage_maildistribution_resend')),
    )

    manage_options = ( 
           {'label': _('Distribution'),         'action': 'manage_maildistribution',    'filter':filter_maildistribution, 'help':('IIGFS','MailDistribution.stx')},
    )


    last_send_date = ""
    last_send_maillist = []
    last_send_count = 0

    manage_maildistribution = HTMLFile('dtml/manage_maildistribution', globals()) 

    def __init__(self,id) :
        pass        
        
    def is_empty_maillist(self) :
        return 0 == len(self.filter_empty_string(self.last_send_maillist))

    def getmailaddressline(self) :
        return string.join(self.filter_empty_string(self.last_send_maillist),',')

    def getbodymessage(self,**kw) :
#          
        return self.call_method('view_messagebody',kw)

    def getmaildistributions(self,REQUEST=None) :
#         
        f = self.cfg('getmaildistributions',[])
        if callable(f) :
            return apply(f,(self,REQUEST),{})
        return f

    def message_send(self,client=None,REQUEST=None,**kw) :
#         
        if self.is_empty_maillist() :
            raise ValueError, MessageDialog(
                    title = _('Empty Recipient List'),
                    message = _('Empty Recipient List'),
                    action = 'manage_maildistribution'
            )
                
        s = self.call_method('mailtemplate',kw)
        return s

    def manage_maildistribution_send(self,REQUEST=None) :
        """      """

        self.last_send_maillist = self.getmaildistributions()
        self.manage_maildistribution_resend(None)

        if REQUEST is not None :
            message=_('Letter sent')
            return self.manage_maildistribution(self,REQUEST, manage_tabs_message=message)

    def manage_maildistribution_resend(self,REQUEST=None) :
        """       """

        self.message_send(self,REQUEST)
        self.last_send_date = DateTime.DateTime()
        self.last_send_count += 1

        if REQUEST:
            message=_("Letter re-sent")
            return self.manage_maildistribution(self,REQUEST, manage_tabs_message=message)

default__class_init__ (MailDistribution)

