__doc__ = """\
Project:Cache of Formated Text
Start:  Sun Feb 24 21:12:37 MSK 2002
Author: Andrey Orlov  (c) 2002
Version:$Id: TextFormatAware.py,v 1.7 2002/11/24 20:26:33 cray Exp $

Title:
        Cache of Formated Text / TextFormatAware 

Description:

        Class, allowed format text with some preinstall
        formats. This are to use as mix-in for some 
        predifined attribute formating. Id of this
        attribute are to assigned to _formated_attribute
        property;

Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied 
        
TODO:   
        Nothing
        
"""
__version__ = '$Revision: 1.7 $'[10:-1]
# $Source: /var/lib/cvs/IIGFS/zope/Products/OtherBases/TextFormatAware.py,v $

from Globals import default__class_init__
from AccessControl.SecurityManagement import getSecurityManager

from MOFS import l10n
_ = l10n.getL10n_decoder(__file__,'OtherBases')

class TextFormatAware :
    """ MixIn   """
    
    format = 'Default'
    _formated_attribute = '_formated_data'
    _formated_data = ''

    _properties = (
        { 'id' : 'format', 'name':_('Contents format'), 'type':'selection', 'select_variable': 'formaters', 'mode':'rw'},
    )
    
    __ac_permissions__ = (
        ('Change Text Format',      ('set_format_way',)),
        ('View IIGFS',              ('formated','format')),
        ('View IIGFS managment',    ('formaters',)),
    )
    
    def formaters(self) :
        try :
            f = self.TextFormatCache
        except AttributeError :
            return [('Default',_('Default'))] 
        else :
            return [('Default',_('Default'))] + f.formaters()
    
    def formated(self,size=None) :
        try :
            cache = self.TextFormatCache
        except AttributeError :
            return getattr(self,self._formated_attribute)
        else :
            if self.format == 'Default' :
                format = self.cfg('default_format',None)
            else :    
                format = self.format
             
            if not format :   
                return getattr(self,self._formated_attribute)

            return cache.use_cache(self,self._formated_attribute,format)
        
    def set_format_way(self,way) :
        if getSecurityManager().checkPermission('Change Text Format', self) :
            self.format = way
        
default__class_init__ (TextFormatAware)
        