__doc__ = """\
Project:IIGFS
Start:  Sun Feb 24 21:12:37 MSK 2002
Author: Andrey Orlov  (c) 2002
Version:$Id: WEBFormSupport.py,v 1.30 2002/11/24 20:26:33 cray Exp $

Title:
        IIGFS / Support for Web Form this auto-generate and 
            checks;

Description:
        WEBFormSupport -      
           .

            form_variables,  
           :

        { id: '< >', type: '< >', # text,
         string, selection, boolean, multiple selection name: '<
         >', mode: '<    >'
         value: '<>',
        }

             form_flags,  
           :

        { id: '<  ( )>', name: ' ',
        }

              
        .     
         form_check,   :

        { id: '< >', type: '< >', #
            +/- -  regexp  .
          expr: '<  >', msg:
         '   '
        }

            - form_construction(self,REQUEST) - 
           - form_check(sefl,REQUEST)


Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied 
        
TODO:   
        Nothing
        
"""
__version__ = "$Revision: 1.30 $"
# $Source: /var/lib/cvs/IIGFS/zope/Products/OtherBases/WEBFormSupport.py,v $

from Globals import default__class_init__
import string,re

from MOFS import l10n
_ = l10n.getL10n_decoder(__file__,'OtherBases')
HTMLFile = l10n.HTMLFile

class WEBFormSupport :
    """    -"""

    meta_type = 'WEBFormSupport' 

    _properties =   (
        {'id':'commit_text', 'name':_('Button sign'), 'type': 'string',  'mode':'w'},
        {'id':'commit_variable', 'name':_('Attribute \"name\" of the button'), 'type': 'string',  'mode':'w'},
        {'id':'include', 'name':_('Include into Request'), 'type': 'tokens',  'mode':'w'},
        {'id':'exclude', 'name':_('Exclude from Request'), 'type': 'tokens',  'mode':'w'},
        {'id':'action',  'name':_('Handler'), 'type':'selection', 'select_variable':'action_items', 'mode':'w'},
        {'id':'form_flags_other', 'name':_('Extended options'), 'type': 'string',  'mode':'w'},
 #       {'id':'datasource', 'name':_('Default datasource'), 'type': 'string',  'mode':'w'},
    )

    __ac_permissions__= (
        ('View IIGFS managment',    ('form_flags_other_items',)),
        ('Change IIGFS',            ()),
        ('Change IIGFS Executable', ()),
        ('Change IIGFS WEBForm',    ('manage_form_variables','manage_form_variables_edit',
                'manage_form_variables_delete','manage_form_variables_first','manage_form_variables_add',
                'manage_form_checks','manage_form_checks_edit','manage_form_checks_add','manage_form_checks_delete')),
        ('View IIGFS',              ('get_form_variables','view_ok','view_form','view_result')),
        ('Use IIGFS Form',              ('request_check','internal_wrapper',)),

    )

    manage_options = ( 
        {'label': _('Form'),              'action': 'manage_form_variables', 'help':('IIGFS','WEBFormFields.stx')},
        {'label': _('Requirements'),        'action': 'manage_form_checks',  'help':('IIGFS','WEBFormCond.stx')},
    )


    form_variables = []
    form_checks    = []
    form_flags     = [{'id':'r', 'name':_('Field required')}, {'id':'x','name':_('Data source default')}]
    form_flags_other = ""
    commit_text    = ""
    commit_variable= ""
    include        = []
    exclude        = []
    action         = ""
    action_items   = (('',_('Skip')),)
#    datasource     = ""

    def field_types(self) :
        return self.cfg('possible_types',['string', 'boolean', 'password',
                'separator', 'text', 'file',
                'selection', 'multiple selection', 'submit'])

    manage_form_variables = HTMLFile('dtml/form_variables', globals()) 

    def __init__(self,id) :
        self.form_variables = self.form_variables[:]
        self.form_checks    = self.form_checks[:]
        self.form_flags     = self.form_flags[:]
        
        
    def manage_form_variables_edit(self,vars,REQUEST=None) :
        """ """

        for item in vars :
            d = self.form_variables[item.num]
            d['id']  = item.id
            d['name']  = item.name
            d['value']  = item.value
            mode = ''
            for fl in self.form_flags :
                if hasattr(item,'fl'+fl['id']) :
                   mode += fl['id']

            for c in self.form_flags_other_items() :
                if hasattr(item,'fl'+c) :
                   mode += c

            d['mode'] = mode
        
        self.__changed__(1)     

        if REQUEST:
            message=_('Changes saved')
            return self.manage_form_variables(self,REQUEST,
                                              manage_tabs_message=message)

    def manage_form_variables_delete(self,nums=None,REQUEST=None) :
        """ """
        if nums is None :
            return MessageDialog(
                   title=_('Select properties to delete'),
                   message=_('Select properties to delete!'),
                   action ='./manage_form_variables',)
        nums.reverse()
        for num in nums :
            del(self.form_variables[num])

        self.__changed__(1)     

        if REQUEST:
            message=_("Variables deleted.")
            return self.manage_form_variables(self,REQUEST,
                                              manage_tabs_message=message)

    def manage_form_variables_first(self,nums=None,REQUEST=None) :
        """ """
        if nums is None :
            return MessageDialog(
                   title=_('Select properties to delete'),
                   message=_('Select properties to delete!'),
                   action ='./manage_form_variables',)

        n = 0
        for num in nums :
            self.form_variables.insert(n,self.form_variables[num])
            n = n + 1
            del(self.form_variables[num+1])

        self.__changed__(1)     

        if REQUEST:
            message=_("Variables re-ordered.")
            return self.manage_form_variables(self,REQUEST,
                                              manage_tabs_message=message)

    def manage_form_variables_add(self,id,name,value,type,mode=[],REQUEST=None) :
        """ """
        self.form_variables.append({'id':id, 'name':name, 'value':value, 'type':type, 'mode':string.join(mode,'')})
        self.__changed__(1)     

        if REQUEST:
            message=_("Variable added")
            return self.manage_form_variables(self,REQUEST,
                                              manage_tabs_message=message)

    manage_form_checks = HTMLFile('dtml/form_checks', globals())

    def manage_form_checks_edit(self,checks,REQUEST=None) :
        """ """
        
        for item in checks :
            d = self.form_checks[item.num]
            d['type'] = item.type
            d['expr'] = item.expr
            d['msg']  = item.msg
        
        self.__changed__(1)     
        if REQUEST:
            message=_("Checking requirements changed") 
            return self.manage_form_checks(self,REQUEST,
                                              manage_tabs_message=message)

    def manage_form_checks_add(self,id,type,expr,msg,REQUEST=None) :
        """ """
        self.form_checks.append({'id':id, 'expr':expr, 'type':type, 'msg':msg})
        self.__changed__(1)     
        if REQUEST:
            message=_("Checking requirement added")
            return self.manage_form_checks(self,REQUEST,
                                              manage_tabs_message=message)

    def manage_form_checks_delete(self,nums=None,REQUEST=None) :
        """ """
        if nums is None :
            return MessageDialog(
                   title=_('Select requirements to delete'),
                   message=_('Select requirements to delete!'),
                   action ='./manage_form_checks',)

        nums.reverse()
        for num in nums :
            del(self.form_checks[num])
        
        self.__changed__(1)     
        if REQUEST:
            message=_("Checking requirements deleted")
            return self.manage_form_checks(self,REQUEST,
                                              manage_tabs_message=message)

    def get_form_hash(self,vars=None,types=None) :
        d = {}
        if vars is None :
            vars =  self.get_form_variables(types)
        for item in vars :
            d[item['id']] = item['default']
        return d

    def get_form_fields(self,types=None) :
        if types is None :
             return self.form_variables
        else :
             fvs = []
             if type(types) == type('') :
                types = (types,)
             for item in self.form_variables :
                if item['type'] in types :
                    fvs.append(item)
             return fvs
                
    def get_form_variables(self,types=None) :
        res = []
        for item in self.get_form_fields(types) :
            item = item.copy()
            default = item['value']
            if 'x' in item['mode'] :
                f = getattr(self,default)
                if callable(f) :
                    default = apply(getattr(self,default),(self,self.REQUEST),item)
                else :
                    default = f
            item['default'] = self.request_default(item['id'],default)
            res.append(item)
            
        return res
                
    def request_check(self,**kw) :
        vars = {}
        for item in self.form_checks :
           if item['type'] == 'exist' :
                if not self.REQUEST.has_key(item['id']) :
                    self.request_msg_append(item['id'],item['msg'])
                    vars[item['id']] = 1
           elif self.REQUEST.has_key(item['id']) :
                if item['type'] == 'regexp_true' :
                    reg = re.compile(item['expr'])
                    if not reg.search(self.REQUEST[item['id']]) : 
                        self.request_msg_append(item['id'],item['msg'])
                elif item['type'] == 'regexp_false' :
                    reg = re.compile(item['expr'])
                    if reg.search(self.REQUEST[item['id']]) : 
                        self.request_msg_append(item['id'],item['msg'])
                elif item['type'] == 'external' :
                    r = apply(getattr(self,item['expr']),(self,self.REQUEST),{'value':self.REQUEST[item['id']]}) 
                    if type(r) is type("") :
                        self.request_msg_append(item['id'],r)
                    elif type(r) in (type([]),type(())) :
                        for msg in r :
                            self.request_msg_append(item['id'],msg)
                    elif not r :
                         self.request_msg_append(item['id'],item['msg'])
                elif item['type'] == 'skip' :
                    continue
           elif vars.has_key(item['id']) :
                continue
           else :
                self.REQUEST[item['id']]

        return self.request_msg_check()

    def form_flags_other_items(self) :
        return list(self.form_flags_other)

    def internal_wrapper(self,REQUEST={},**kw) :
        if self.REQUEST.has_key(self.commit_variable) :
            if not self.request_check() :
                msg = _("Nothing has been done")
                if self.action :
                        msg = self.restrictedTraverse(self.action)(REQUEST)
                return self.view_ok(msg=msg)
            else :
                return self.view_form()
        else :
            return self.view_form()

#    view_ok = HTMLFile('dtml/WEBFormSupport_ok', globals()) 
#    view_form = HTMLFile('dtml/WEBFormSupport_form', globals()) 
#    view_result = HTMLFile('dtml/WEBFormSupport_result', globals()) 

default__class_init__ (WEBFormSupport)
